from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, File, Float, Boolean, Directory

Velvetg_V0_1_0 = CommandToolBuilder(tool="velvetg", base_command=["velvetg"], inputs=[ToolInput(tag="in_cov_cut_off", input_type=String(optional=True), prefix="-cov_cutoff", doc=InputDocumentation(doc=": removal of low coverage nodes AFTER tour bus or allow the system to infer it\n(default: no removal)")), ToolInput(tag="in_ins_length", input_type=Int(optional=True), prefix="-ins_length", doc=InputDocumentation(doc=": expected distance between two paired end reads (default: no read pairing)")), ToolInput(tag="in_read_tr_kg", input_type=String(optional=True), prefix="-read_trkg", doc=InputDocumentation(doc=": tracking of short read positions in assembly (default: no tracking)")), ToolInput(tag="in_min_contig_lgth", input_type=Int(optional=True), prefix="-min_contig_lgth", doc=InputDocumentation(doc=": minimum contig length exported to contigs.fa file (default: hash length * 2)")), ToolInput(tag="in_amos_file", input_type=File(optional=True), prefix="-amos_file", doc=InputDocumentation(doc=": export assembly to AMOS file (default: no export)")), ToolInput(tag="in_exp_cov", input_type=String(optional=True), prefix="-exp_cov", doc=InputDocumentation(doc=": expected coverage of unique regions or allow the system to infer it\n(default: no long or paired-end read resolution)")), ToolInput(tag="in_long_cov_cut_off", input_type=String(optional=True), prefix="-long_cov_cutoff", doc=InputDocumentation(doc=": removal of nodes with low long-read coverage AFTER tour bus\n(default: no removal)")), ToolInput(tag="in_ins_length_long", input_type=Int(optional=True), prefix="-ins_length_long", doc=InputDocumentation(doc=": expected distance between two long paired-end reads (default: no read pairing)")), ToolInput(tag="in_scaffolding", input_type=String(optional=True), prefix="-scaffolding", doc=InputDocumentation(doc=": scaffolding of contigs used paired end information (default: on)")), ToolInput(tag="in_max_branch_length", input_type=Int(optional=True), prefix="-max_branch_length", doc=InputDocumentation(doc=": maximum length in base pair of bubble (default: 100)")), ToolInput(tag="in_max_divergence", input_type=Float(optional=True), prefix="-max_divergence", doc=InputDocumentation(doc=": maximum divergence rate between two branches in a bubble (default: 0.2)")), ToolInput(tag="in_max_gap_count", input_type=Int(optional=True), prefix="-max_gap_count", doc=InputDocumentation(doc=": maximum number of gaps allowed in the alignment of the two branches of a bubble (default: 3)")), ToolInput(tag="in_min_pair_count", input_type=Int(optional=True), prefix="-min_pair_count", doc=InputDocumentation(doc=": minimum number of paired end connections to justify the scaffolding of two long contigs (default: 5)")), ToolInput(tag="in_max_coverage", input_type=String(optional=True), prefix="-max_coverage", doc=InputDocumentation(doc=": removal of high coverage nodes AFTER tour bus (default: no removal)")), ToolInput(tag="in_coverage_mask", input_type=Int(optional=True), prefix="-coverage_mask", doc=InputDocumentation(doc=": minimum coverage required for confident regions of contigs (default: 1)")), ToolInput(tag="in_long_mult_cut_off", input_type=Int(optional=True), prefix="-long_mult_cutoff", doc=InputDocumentation(doc=": minimum number of long reads required to merge contigs (default: 2)")), ToolInput(tag="in_unused_reads", input_type=File(optional=True), prefix="-unused_reads", doc=InputDocumentation(doc=": export unused reads in UnusedReads.fa file (default: no)")), ToolInput(tag="in_alignments", input_type=String(optional=True), prefix="-alignments", doc=InputDocumentation(doc=": export a summary of contig alignment to the reference sequences (default: no)")), ToolInput(tag="in_export_filtered", input_type=String(optional=True), prefix="-exportFiltered", doc=InputDocumentation(doc=": export the long nodes which were eliminated by the coverage filters (default: no)")), ToolInput(tag="in_clean", input_type=String(optional=True), prefix="-clean", doc=InputDocumentation(doc=": remove all the intermediary files which are useless for recalculation (default : no)")), ToolInput(tag="in_very_clean", input_type=String(optional=True), prefix="-very_clean", doc=InputDocumentation(doc=": remove all the intermediary files (no recalculation possible) (default: no)")), ToolInput(tag="in_paired_exp_fraction", input_type=Float(optional=True), prefix="-paired_exp_fraction", doc=InputDocumentation(doc=": remove all the paired end connections which less than the specified fraction of the expected count (default: 0.1)")), ToolInput(tag="in_short_mate_paired", input_type=Boolean(optional=True), prefix="-shortMatePaired", doc=InputDocumentation(doc="* <yes|no>      : for mate-pair libraries, indicate that the library might be contaminated with paired-end reads (default no)")), ToolInput(tag="in_conserve_long", input_type=String(optional=True), prefix="-conserveLong", doc=InputDocumentation(doc=": preserve sequences with long reads in them (default no)")), ToolInput(tag="in_directory", input_type=Directory(), position=0, doc=InputDocumentation(doc=": working directory name"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Velvetg_V0_1_0().translate("wdl", allow_empty_container=True)

